#ifndef _GLTGAPARSER_H_
#define _GLTGAPARSER_H_

#if _MSC_VER > 1000
#pragma once
#endif 

#include "GLImage.h"
#include <stdio.h>
#include <stdlib.h>

typedef unsigned char byte;

/****************************************************************************
*
*	CLASSNAME:		GLTGAPARSER		 
*
*	DESCRIPTION:	S'encarrega de fer les conversions entre Fitxer TGA i
*					Objectes GLImage. Es pot Llegir o escriure de fitxer.
*
****************************************************************************/
/****************************************************************************
*   <table border=2 bgcolor=green>
*	<tr><td><b>Version	</b></td><td> 1.0				</td></tr>
*	<tr><td><b>Author	</b></td><td> Citem Simulation Grup	</td></tr> 
*	<tr><td><b>Data		</b></td><td> -- / -- / 2001	</td></tr>
*	<tr><td><b>e-mail	</b></td><td><a href="mailto:tm06521@salleurl.edu"> 
*									  tm06521@salleUrl.edu
*									 </a></td></tr>
*	<tr><td><b>To do	</b></td><td>					</td></tr>
*	</table>
*****************************************************************************/

class GLTGAParser  
{

	static int width;
	static int height;
	static int bits;
	static int size;
	static GLenum format;

public:
	// Escriu la GLImage "image" al fitxer.tga "filename"
	static bool writeToFile(char* fileName, GLImage &img);
	// Carrega a GLImage "image" el fitxer.tga "filename"
	static bool load(char* fileName, GLImage &img);


	GLTGAParser();
	virtual ~GLTGAParser();

private:
	static byte* loadRGBA( FILE* strm, int size );
	static byte* loadRGB( FILE* strm, int size );
	static byte* loadGray( FILE *strm, int size );
	static byte* loadData( FILE* strm, int size );
};

#endif // !defined(AFX_GLTGAPARSER_H__4EE6AD17_EED2_4103_81B3_99A196C862DC__INCLUDED_)
