#ifndef _NETWORKH_H_
#define _NETWORKH_H_

#if WIN32
	// Cal linkar wsock32.lib
	#include <windows.h>
	#include <winsock.h>
	#include <malloc.h>
	#include <direct.h>
	#define mkdir(str,str2) mkdir(str)
#else
	#include <netinet/in.h>
	#include <unistd.h>
	#include <sys/socket.h>
	#include <netdb.h>
	#include <sys/stat.h>
#endif
	#include <stdio.h>
	#include <stdlib.h>
	#include <string.h>
	#include <sys/types.h>
	#include "define.h"
	#include "stage.h"
	#include <SDL/SDL_thread.h>

extern unsigned int crc32(char *buf,long len);
extern char *makeDirs(char *str);
extern void killProgram(int mode);

class Networkh
{
	char *hostname,
		key[4];
	int port,s,bsize;
	stage *stg;
	char nickSend[30], pass[30];
	bool CONECTED;
	bool RECIVING;
			
private:

	void cli_reciveKey();
	void cli_reciveVers();
	void cli_packetErr();
	void cli_reciveTalk();
	void cli_checkFile();
	void cli_saveFile();
	void cli_recivePart();
	void cli_reciveItem();
	void cli_reciveBegin();
	void cli_reciveWeapon(),
	     cli_reciveMove(),
		cli_reciveOkOk(),
		cli_reciveJoin(),
		cli_killFlag(),
		cli_reciveShot(),
		cli_reciveRole();
	int cli_sendUser(char *user),
		cli_sendPass(char *pass),
		cli_sendOkOk();

public:
	int cli_sendTalk(char *talk),
	cli_sendNick(char *nick),
	cli_sendMove(GL3f pos,int rot, int ani),
	cli_sendWeap(int weap);
	void cli_sendShot(float x,float y,float z,float vx,float vy, float vz);
	
	int start(void *mmh);
	void setStage(stage *stg);
	Networkh(char *hostname="localhost",char *login="anonim", char *pass="null",int port=9999,int bsize=1024);
	~Networkh();

	bool conected();
};

int useThread(void *net);

#endif



