#include "TGAload.h"
	

char *TGAload(char *file,int *w, int *h, int *bpp)
{
	FILE *fd=0;
	char *filebuf;
	char *tex;
	long fsize=0;
	long i;
	int size;
	
	#ifdef BZIP2
	char a[BZ_MAX_UNUSED];
	int bzerr=0,nread=0;
	char obuf[1024];
	BZFILE *bzf=0;
	#endif
	
	chdir(getDirs(file)); 
	fd=fopen(file,"rb");

	if (!fd) 
	{
	  system("pwd");
	  printf("Error loading texture %s\n",file);
	  throw 0;
	};
	chdir("../..");

	// is bzip2 tga?
	#ifdef BZIP2
	bzf=BZ2_bzReadOpen(&bzerr,f,0,0,a,0);
	if (!bzf)
	printf("SUXED\n");
	filebuf=(char *)malloc(1);
	while(!bzerr)
	{
		nread=BZ2_bzRead(&bzerr,bzf,obuf,1024);

		if ((!bzerr||bzerr==BZ_STREAM_END) && nread) {
			filebuf=(char *)realloc(filebuf,fsize+nread);
			memcpy(filebuf+fsize,obuf,nread);
			fsize+=nread;
			}
		} 
	if (bzerr&&bzerr!=BZ_STREAM_END) { //isn't bzip2
	#endif
	
	fseek (fd, 0,SEEK_END); // Move to the end
	fsize=ftell(fd);      // Get file size
	fseek(fd,0,SEEK_SET); // Move to the beggining
	filebuf=(char *)malloc(fsize);
	fread(filebuf,fsize,1,fd); // read file to buffer.

	#ifdef BZIP2
	}
	#endif
	// Check Header
	i=TGAHEAD; // header size
	while((--i==2)?--i:i)(filebuf[i])?throw 1:i;
	*w=(filebuf[TGAHEAD+1]*256)+filebuf[TGAHEAD+0];
	*h=(filebuf[TGAHEAD+3]*256)+filebuf[TGAHEAD+2];

	if (*w<0) (*w)*=-1;
	if (*h<0) (*h)*=-1;

	*bpp=filebuf[TGAHEAD+4];

	if (w&&h)	size=(*w)*(*h)*(*bpp/8);
	else throw 3; 		// throw if null image
	tex=(char *)malloc(fsize);
	if ((*w)*(*h)*(*bpp/8)>fsize) throw 4;
	for(i=0;i<size;i+=(*bpp/8)) // BGR 2 RGB and BPP conversion
	{
		if (*bpp==32){
			tex[i+0]=filebuf[TGAMAP32+i+3];
			tex[i+1]=filebuf[TGAMAP32+i+2];
			tex[i+2]=filebuf[TGAMAP32+i+1];
			tex[i+3]=filebuf[TGAMAP32+i+0];
		} else {
			tex[i+0]=filebuf[TGAMAP24+i+2];
			tex[i+1]=filebuf[TGAMAP24+i+1];
			tex[i+2]=filebuf[TGAMAP24+i+0];
		}
	}
	free (filebuf);      // Alliberem el buffer.

	fclose(fd);

	return tex;
}




