#include "TexManager.h"

TexId TexManager::getTexture( char *file_name ) {
	TexId tid;

	map<string,TexId>::const_iterator it_tex;
	it_tex = m_mapTextures.find(file_name);
	if( it_tex != m_mapTextures.end() ) {
		tid = it_tex->second;
	} else {
		// La textura no est carregada. La carreguem
		glEnable(GL_TEXTURE_2D);
		glTexEnvi(GL_TEXTURE,GL_TEXTURE_ENV_MODE,GL_MODULATE);

		glGenTextures(1,&tid);
		m_mapTextures[string(file_name)] = tid;
		
		glBindTexture(GL_TEXTURE_2D,tid);
		glPixelStorei(GL_UNPACK_ALIGNMENT,1);
		glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_WRAP_S,GL_REPEAT);
		glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_WRAP_T,GL_REPEAT);
		glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_MAG_FILTER,GL_LINEAR_MIPMAP_LINEAR);
		glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_MIN_FILTER,GL_LINEAR_MIPMAP_LINEAR);

		image = new GLImage();
		GLTGAParser::load(file_name, *image);
		switch ( image->m_format ) {
			case GL_RGB:
				gluBuild2DMipmaps(GL_TEXTURE_2D,GL_RGB,image->getWidth(),image->getHeight(),GL_RGB,GL_UNSIGNED_BYTE,image->getData());
				break;
			case GL_RGBA:
				gluBuild2DMipmaps(GL_TEXTURE_2D,GL_RGBA,image->getWidth(),image->getHeight(),GL_RGBA,GL_UNSIGNED_BYTE,image->getData());
				break;
		}
		delete image;
	}
	return tid;
}



