/**
 * Classe encarregada de manipular les textures.
 * Utilitza el patr de disseny del singleton.
 * Noms hi haur una instncia d'aquesta classe en tot el nostre programa
 * Per utilitzar-la fer getTexManager->getTexture();
 */

#ifndef _TEXMANAGER_H_
#define _TEXMANAGER_H_

#include "GLImage.h"
#include "GLTGAParser.h"

#pragma warning(disable: 4018)  // signed/unsigned mismatch
#pragma warning(disable: 4100)  // unreferenced formal parameter
#pragma warning(disable: 4245)  // conversion from 'type1' to 'type2', 
                                // signed/unsigned mismatch
#pragma warning(disable: 4512)  // 'class' : assignment operator could not be generated
#pragma warning(disable: 4663)  // C++ language change: to explicitly specialize 
                                // class template 'vector'
#pragma warning(disable: 4710)  // 'function' : function not inlined
#pragma warning(disable: 4786)  // identifier was truncated to 'number' characters in 
                                // the debug information
#pragma warning(disable: 4146)  // unary minus operator applied to unsigned type, 
                                // result still unsigned
#pragma warning(disable: 4244)  // 'conversion' conversion from 'type1' to 'type2', 
                                // possible loss of data
#pragma warning(disable: 4511)  // 'class' : copy constructor could not be generated

// BUG: C4786 Warning Is Not Disabled with #pragma Warning
// STATUS: Microsoft has confirmed this to be a bug in the Microsoft product. 
// This warning can be ignored. This occured only in the <map> container.

#include <map>
#include <string>

using namespace std;

// Identificador global de la textura
typedef unsigned int TexId;

// Gestor de textures centralitzat
class TexManager {  
private:
	// Taula de correspondncies entre el nom de la textura i el seu identificador
	map<string,TexId> m_mapTextures;
	
	// Objecte GLImage necessari per carregar la imatge
	GLImage* image;
	//GLImage image;

private:
  	// Constructor privat per obligar a obtenir el TexManager amb el
	// mtode GetTexManager()
	TexManager() {};
  
public:
	// Funci que retorna el Singleton
	static TexManager &getTexManager() {
		static TexManager singleton_TexManager;
		return singleton_TexManager;
	}
  
  	// Retorna l'identificador de la textura, carregant-la prviament si s necessari
	TexId getTexture( char *file_name );
};

#endif
