#ifndef _CARACTER_H_
#define _CARACTER_H_

#include "control.h"
#include "define.h"
#include "weapon.h"

extern void killProgram(int mode);



//Clase q controla los personajes en si
class caracter{
	control **model;               //Array con las 3 partes del cuerpo q tiene el personaje
	GLBounding bounding;           //El bounding total
	GL3f *bodyUnion;               //Array de los puntos que sirven para unir cuerpo y cabeza
	GL3f *legsUnion;               //Array de los puntos que sirven para unir piernas y cuerpo
	GL3f *weaponUnion;             //Array con la posicion d la arma
	GL2f *weaponAngle;             //Array con el angulo d la arma

	weapon *arma;				   //Puntero a la arma seleccionada
	int actualAmmo;

	char nick[100];

public:
	caracter();                    //Constructor de la clase
	~caracter();

	//Le has de pasar el nombre del fichero que almacena el personaje
	void carga(char *ruta);

	//Cojes el bounding total
	GLBounding getBounding();

	//Cojes la posicion
	GL3f getPos();

	//Le das una nueva posicion
	void setPos(GL3f pos);

	//Nueva rotacion
	void setRotation(float angle);

	//Devuelve la rotacion actual
	float getRotation();

#if _PVS	
	//Devuelve el id de la habitacion en la que te encuentras
	int getId();


	//Le asignas un id al personaje
	void setId(int id_old);
#endif

	//Le asignas una animacion al personaje. Espera un integer con las animaciones 
	//y te devuelve true or false dependiendo de si ha habido algun error o no
	bool setAnimation(int animationHead, int animationBody, int animationLegs);

	//Devuelve el objeto control de la posicion que le digas 
	control *getControl(int which);

	//Devuelve un punto de union. Le has de pasar un int con la parte del cuerpo que quieres
	//y en que posicion de la animacion est
	GL3f getUnion (int part, int which=-1);

	GL2f getWeaponRot (int which=-1);
	
	//Actualiza las diferentes partes del cuerpo
	void update();

	//Hace o no invisible al personaje
	void setVisible(bool visible);

	//Devuelve un boleano indicando si se ve el objeto o no
	bool isVisible();

	weapon *getWeapon();

	void setWeapon(weapon weapon_,int numBalas);

	void killEnemy();

	void reviveEnemy();

	bool isDying();

	void setNick(char *nick);

	char *getNick();

};


#endif
