#include "cargaTexturas.h"

void *CargaTGA(char *filename,int *tam,int *tam2)
{
	GLubyte TGAheader[12]={0,0,2,0,0,0,0,0,0,0,0,0};
	GLubyte TGAcompare[12];
	GLubyte header[6];
	GLuint bytesPerPixel;
	GLuint imageSize;
	GLuint temp,i;
	GLuint type=GL_RGBA;
	TGA texture;
	GLubyte *aux;
	chdir(getDirs(filename));
	FILE *file = fopen(filename, "rb");
	chdir("../..");

	if (file == NULL)
	return NULL;
	/* Esto abre y comprueba que es un TGA */
	fread(TGAcompare,1,sizeof(TGAcompare),file);
	if (memcmp(TGAheader,TGAcompare,sizeof(TGAheader))!=0)
	return NULL;

	fread(header,1,sizeof(header),file);
	/* Determinamos el tamao */
	texture.width = header[1] * 256 + header[0];
	texture.height = header[3] * 256 + header[2];

	/* Vemos las caractersticas y comprobamos si son correctas*/
	if( texture.width <=0 ||texture.height <=0 ||texture.width >256 ||texture.height !=texture.width ||( header[4]!=32))
	{
	fclose(file);
	return NULL;
	}
	/* Calculamos la memoria que ser necesaria */
	texture.bpp = header[4];
	bytesPerPixel = texture.bpp/8;
	imageSize = texture.width*texture.height*bytesPerPixel;

	/* Reservamos memoria */
	texture.imageData=(GLubyte *)malloc(imageSize);

	/* Cargamos y hacemos alguna comprobaciones */
	if( texture.imageData==NULL ||
	fread(texture.imageData, 1, imageSize, file)!=imageSize)
	{
		if(texture.imageData!=NULL)
		free(texture.imageData);
		fclose(file);
		return NULL;
	}

	/* El TGA viene en formato BGR, lo pasamos a RGB */
	for(i=0; i<(GLuint)(imageSize); i+=bytesPerPixel)	{
		temp=texture.imageData[i];
		texture.imageData[i] = texture.imageData[i + 2];
		texture.imageData[i + 2] = temp;
	}
	fclose (file);

	/* Ahora, cambiamos el orden de las lneas, como si hiciesemosun flip vertical. */
	aux=(GLubyte *)malloc(imageSize);
	for(i=0; i<texture.height; i++)
	memcpy(&aux[imageSize-((i+1)*texture.width*4)],
	       &texture.imageData[i*texture.width*4],
		   texture.width*4);

	/* tam devolver el tamao */
	*tam=texture.width;
	*tam2=texture.width;

	/* Liberamos memoria */
	free(texture.imageData);

	/* Todo fue bien!*/
	return aux;

}
