#ifndef _DEFINE_H_
#define _DEFINE_H_

#define VERSION 1.0						//The game version

#define _PVS 1							//Define if the PVS is active or not
#define NETWORK 1						//Define if the network is active or not

#define ROTATE_SPEED_ITEMS 10			//Rotation item speed
#define ROTATE_ANGLE_ITEMS 5.0f			//Rotation item angle 

#define MAX_MESSAGES 10					//Max number of messages
#define MAX_MESSAGE_LENGTH 255       //Max message length
#define SPACE_BETWEEN_MESSAGES 15.0f  //Space between messages
#define MESSAGE_X_ORIG 20.0f          //Init point in the x coordenate
#define MESSAGE_TIME_LEFT 4000       //Life of the messages
#define TALK_MESSAGE_Y 45.0f            //Init point in the y coordenate (begining from down)
                                     
#define DESINTEGRATION_DELAY 3			//Desintegration speed of the objects
#define EXPLOSION_DELAY 10				//Explosion speed of the objects

enum{
	SOLO_CARAS,
	SOLO_VERTICES,
	CARAS_Y_VERTICES
};

enum {
	PACKET_PING=0, // [ ] send a ping    usr->svr (n,"username",rnd); svr->usr(from,rnd);
	PACKET_PONG,   // [ ] reply a ping   (n,"username",rnd);
	PACKET_USER,   // [x] Send username  (n,"username");
	PACKET_PKEY,   // [x] Server sends the password key
	PACKET_PASS,   // [x] Send password  (crc); (4 bytes)
	PACKET_ERRR,   // [x] Errror ;)      (n,"errormessage"); -> close connection
	PACKET_VERS,   // [x] Send server Version (version,n,"serverstring");
	PACKET_CHKF,   // [x] Check file     (n,"filename");
	PACKET_CRCF,   // [x] Reply a crc32 of the file requested.
	PACKET_FILE,   // [x] Send a file to the client. (n,"filename",n[4],"filedata");
	PACKET_NICK,   // [x] Change my nick (n,"nick");
	PACKET_TALK,   // [x] Talk message :D
	PACKET_MOVE,   // [x] Move message...100% done
	PACKET_PART,   // [x] Send a broadcast message [header][1 byte of usrenumber]
	PACKET_JOIN,   // [x] JoinMessage (me/nick/rph)
	PACKET_ITEM,   // [x] Item packet [2 bytes]
	PACKET_BEGN,   // [x] Begin is love [x,y,z,r]
	PACKET_WEAP,   // [x] Change Weapon [n]
	PACKET_CHWP,   // [x] Change next weapon
	PACKET_OKOK,    //	[x] Prepared to play? 
	PACKET_DEPS,	//Deps loaded, continue playing
	PACKET_SHOT=21,
	PACKET_ROLE
};

//The parts of the body
enum{
	LEGS,
	BODY,
	HEAD,
	WEAPON_POS
};


//The legs stats
enum{
	NOT_MOVING,
	WALKING_FORWARD,
	WALKING_BACKWARD,
	RUNNING_FORWARD,
	RUNNING_BACKWARD,
	JUMPING,
	CROUCHING,
	STRAFING_LEFT,
	STRAFING_RIGHT
};

//The body stats
enum{
	NOT_SHOOTING_FACE2FACE,
	NOT_SHOOTING_1HAND,
	NOT_SHOOTING_2HAND,
	WALKING_FACE2FACE,
	WALKING_1HAND,
	WALKING_2HAND,
	SHOOTING_FACE2FACE,
	SHOOTING_1HAND,
	SHOOTING_2HAND,
	GETTING_FACE2FACE,
	GETTING_1HAND,
	GETTING_2HAND,
	THROWING_FACE2FACE,
	THROWING_1HAND,
	THROWING_2HAND
};

enum{
	FACE2FACE,
	_1HAND,
	_2HAND
};

enum{
	SHOOTING,
	WALKING,
	NOT_SHOOTING,
	GETTING,
	THROWING
};
	

//The head stats
enum{
	HEAD_NORMAL
};

#endif
