#ifndef _GAME_H_
#define _GAME_H_

#include "structures.h"
#include "stage.h"
#include "render.h"
#include "controles.h"
#include "Networkh.h"


//The main class of the game. It controls all input and output events and has all the info inside
class game{
	stage *fase;				//This will control the information of the stage
 	render *renderScreen;		//This will render everything
	controles *teclado;			//Controls the keyboard
	Networkh *net;				//Controls the sockets connection

public:
    //Default costructor used to init all the vars
	game();

	//Frees memory
	~game();
	
	//Paints the world
	void pintaPantalla();
	
	//Captures especial keys
	void testKeys(Uint8 *k){ teclado->testKeys(k); }
	
	//Captures keyboard events
	void teclat() { teclado->teclat(); }
	
	//Captures mouse events
	void mouseMov(int x, int y){ teclado->mouseMov(x, y);}
};

#endif


