#include "habitacion.h"

habitacion::habitacion(){
}

habitacion::~habitacion(){
#if _PVS
	for (int i=0;i<numPortals;i++){
		delete portalObj[i];
	}
	delete[] portalObj;
#endif

	delete[] vertex;
	delete[] textureVertex;
	delete[] texturePointer;

}

#if _PVS
int habitacion::createPortals(int tempoPortals){
	
	numPortals=tempoPortals;
	portalObj=new portal*[tempoPortals];
	if (!portalObj) return 0;
	return 1;

}


void habitacion::setPortalNeighbour(int where,int vecino){
	portalObj[where]=new portal(vecino);
}


void habitacion::setPortalVertex(int where,GL3f *vertex_old){
	portalObj[where]->setVertex(vertex_old);

}

int habitacion::getNumPortals(){
	return numPortals;
}

int habitacion::getPortalNeighbour(int which){
	return portalObj[which]->getId();
}



GL3f *habitacion::getPortalVertex(int which){
	return portalObj[which]->getVertex();
}
#endif

habitacion::habitacion(int id_temp){
	id=id_temp;
}

int habitacion::getId(){
	return id;
}

void habitacion::addVertex(float *vertexTempo,int numFaces_old){
	numFaces=numFaces_old;

	//Multiplicamos por 9 ya que cada cara tiene 3 vertices y cada vertice 3 componentes (x,y,z)
	vertex=new float[numFaces*9];

	//Hacemos una copia del array
	memcpy(vertex,vertexTempo,sizeof(float)*numFaces*9);
}

void habitacion::addTextureVertex(float *textureVertexTempo, int numTextureFaces_old){
	numTextureFaces=numTextureFaces_old;

	//Multiplicamos por 6 ya que cada cara tiene 3 vertices y cada vertice 2 componentes (u,v)
	textureVertex=new float[numTextureFaces*6];

	//Hacemos una copia del array
	memcpy(textureVertex,textureVertexTempo,sizeof(float)*numTextureFaces*6);
}

int habitacion::getNumFaces(){
	return numFaces;
}

int habitacion::getNumTextureFaces(){
	return numTextureFaces;
}

float *habitacion::getVertex(){
	return vertex;

}

float *habitacion::getTextureVertex(){
	return textureVertex;

}

int habitacion::getFirstTexture(int which){
	if (which>=0 && which<=numTextures) return texturePointer[which*2];
	else return -1;
}

int habitacion::getTextureNumber(int which){
	if (which>=0 && which<numTextures) return texturePointer[(which*2)+1];
	else return -1;
}

int habitacion::getNumTextures(){
	return numTextures;
}

void habitacion::addTexturePointer(int *texturePointer_old,int numTextures_old){
	numTextures=numTextures_old;

	//Multiplicamos por 2 el numero de texturas ya que en el primer campo le defines en que
	//parte del array empiezas a utilizarla y en el segundo a que textura del mapa te refieres.
	//Por ultimo le sumas uno donde colocas la longitud del array
	texturePointer=new int[(numTextures_old*2)+1];

	//Creas una copia del array
	memcpy(texturePointer,texturePointer_old,sizeof(float)*((numTextures_old*2)+1));

}



