#ifndef _HABITACION_H_
#define _HABITACION_H_

#include "structures.h"
#include "portal.h"
#include "Object3D.h"

class habitacion{

#if _PVS
	portal **portalObj;         //Array con todos los portales
	int numPortals;             //Numero de portales
#endif
	int id;                     //Id de la habitacion
	int numFaces;               //Numero de caras
	int numTextureFaces;        //Numero de caras de textura
	int numTextures;            //Numero de texturas
	float *vertex;              //Array de vertices
	float *textureVertex;       //Array de vertices de textura
	int *texturePointer;        //Array donde se guarda a partir de donde
	                            //(en el array de vertices) empieza una textura
	                            //y, a continuacion, la textura a la q se refiere

public:

    //Constructor por defecto q inicializa variables
	habitacion();
	
	//Constructor por defecto al q se le pasa un integer q define de que
	//habitacion se trata
	habitacion(int id_temp);

	//Destructor
	~habitacion();
	
	//Funcion q retorna el id de la habitacion actual
	int getId();

#if _PVS	
	//Funcion a la q le pasas el numero de portales y te
	// inicializa un array de estos
	int createPortals(int tempoPortals);
	
	//Funcion q define a q habitacion apunta un portal.
	//Espera un integer con q portal es y otro con la habitacion donde
	//apunta
	void setPortalNeighbour(int where,int vecino);
	
	//Le definimos los vertices a un portal
	void setPortalVertex(int where,GL3f *vertex_old);
	
	//Le dices un portal y te devuelve a que habitacin apunta
	int getPortalNeighbour(int which);
	
	//Le dices un portal y te devuelve un array de GL3f con sus vertices
	GL3f *getPortalVertex(int which);
	
	//Te devuelve el numero de portales q tiene la habitacion
	int getNumPortals();

#endif

	//Aadimos los vertices de la habitacion.
	//Espera un array de floats con el numero de vertices
	void addVertex(float *vertexTempo,int numFaces_old);
	
	//Aadimos los vertices de textura a la habitacion
	//Espera un array de floats con el numero de vertices de textura
	void addTextureVertex(float *textureVertexTempo,int numTextureFaces_old);
	
	//Devuelve el numero de caras
	int getNumFaces();
	
	//Devuelve el numero de caras de la textura
	int getNumTextureFaces();
	
	//Devuelve un array de floats con los vertices de la habitacion
	float *getVertex();
	
	//Devuelve un array de floats con los vertices de textura de la habitacion
	float *getTextureVertex();
	
	//Le pasas el numero de textura de la habitacion
	// y te devuelve donde empieza esa textura en los vertices
	int getFirstTexture(int which);
	
	//Le pasas el numero de textura de la habitacion y te devuelve a que textura
	//del mapa se refiere
	int getTextureNumber(int which);
	
	//Devuelve el numero de texturas de la habitacion
	int getNumTextures();
	
	//Le pasas un array con los texturePointer (el primer parametro es
	//donde empieza la textura en el array de vertices y el segundo es
	//la textura del mapa a la q se refiere). Despues le pasas el numero
	//de texturas q tiene la habitacion
	void addTexturePointer(int *texturePointer_old,int numTextures_old);

};

#endif 
