#include "help.h"
#include "TexManager.h"

GL3f getBoundingPos(GLBounding bounding)
{
	return GL3f(    (bounding.getXmax()-bounding.getXmin())+bounding.getXmin(),
			(bounding.getYmax()-bounding.getYmin())+bounding.getYmin(),
			(bounding.getZmax()-bounding.getXmin())+bounding.getZmin() );
}

void glEnter2D(int width, int height)
{
  glPushMatrix();
  glMatrixMode( GL_PROJECTION);
  glDisable(GL_DEPTH_TEST);
  glLoadIdentity();
  gluOrtho2D(0,width,0,height);
  glMatrixMode( GL_MODELVIEW);
  glLoadIdentity();
     
}

void glExit2D()
{
	glPopMatrix();
	glEnable(GL_DEPTH_TEST);
}

void drawImage(char *file, bool invert)
{
	glEnter2D(WIDTH,HEIGHT);

	glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT); 
	glEnable(GL_TEXTURE_2D);

	chdir(getDirs(file)); 
	glBindTexture(GL_TEXTURE_2D, TexManager::getTexManager().getTexture(file));
	chdir("../..");

	glBegin(GL_QUADS);
		if (!invert) glTexCoord2f(1.0f,1.0f);
		else glTexCoord2f(1.0f,0.0f);
		glVertex3f((float)WIDTH,(float)HEIGHT,0.0f);

		if (!invert) glTexCoord2f(0.0f,1.0f);
		else glTexCoord2f(0.0f,0.0f);
		glVertex3f(0.0f,(float)HEIGHT,0.0f);

		if (!invert) glTexCoord2f(0.0f,0.0f);
		else glTexCoord2f(0.0f,1.0f);
		glVertex3f(0.0f,0.0f,0.0f);

		if (!invert) glTexCoord2f(1.0f,0.0f);
		else glTexCoord2f(1.0f,1.0f);
		glVertex3f((float)WIDTH,0.0f,0.0f);
	glEnd();

	glDisable(GL_TEXTURE_2D);
	SDL_GL_SwapBuffers( );

	glExit2D();
}

void glhRandomize()
{
  time_t seconds;
  seconds = time (NULL);
  srand(seconds);
}
