#include "main.h"

int
main(int argc, char **argv)
{
	FILE *fd;
	char buf[80];

   	//Here we read the audio configuration file
	fd=fopen("config.snh","r");
	if (!fd) 
	{
		printf("config.snh not found...loading defaults.\n");
		SOUND_ENABLED=1;
		SOUND_VOLUME=100;
	}
	else
	{
	while(!feof(fd))
		{
		buf[0]=0;
		fscanf(fd,"%s",buf);
		if (!strcmp("ENABLE",buf)) 
			fscanf(fd,"%d",&SOUND_ENABLED);
		else if (!strcmp("VOLUME",buf)) 
			fscanf(fd,"%d",&SOUND_VOLUME);
		}
	fclose(fd);
	}

	// We create the object that will control the game
	juego=new game();

	// The main game loop :)
	for (;;)
	{
		//Let's paint it all
		juego->pintaPantalla();
		//Here we swap the buffers
		SDL_GL_SwapBuffers( );
		
		renderDelay=SDL_GetTicks()-lastRender;
		lastRender=SDL_GetTicks();

		//Let's see if any key is pressed
		juego->teclat();
	}

return 1;
}


void killProgram(int mode)
{
	delete juego;
	SDL_Quit();

	printf("SDL INTERFACE DESTROYED\n");
	
	if (!mode) printf("EXECUTION ERROR\n");
	else printf("EXECUTION FINALIZED CORRECTLY\n");

	// Show Credits
	printf("\nGLH V.0.1 IS DOWN\n\n"
	       "******* GLH TEAM **************************************************************\n"
	       "*                                                                             *\n"
	       "*  ENGINE PROGRAMMER: Ankh (David Barrachina Martinez)                        *\n"
	       "*  CONTROLS, AUDIO AND NETWORK PROGRAMMER: Pancake (Sergi Alvarez Capilla)    *\n"
	       "*  DESIGNER AND 3D MODELATOR: Konstan (Marc Vidal Xarto)                      *\n"
	       "*  SUPERVISOR: The OpenGL Profe (Vicenc Garcia)                               *\n"
	       "*                                                                             *\n"
	       "*******************************************************************************\n"
	       "*                                                                             *\n"
	       "*                       LA SALLE GRACIA 2003 - BARCELONA                      *\n"
	       "*                                                                             *\n"
	       "*******************************************************************************\n"
	       "*                                                                             *\n"
	       "*                 CHECK FOR NEW VERSIONS IN: http://glh.sf.net                *\n"
	       "*                             THANKS FOR PLAYING!!!                           *\n"
	       "*                                                                             *\n"
	       "*******************************************************************************\n");
	exit(mode);
}



