#ifndef _MAP_H_
#define _MAP_H_

#include "habitacion.h"
#include "TGAload.h"
#include "GL/glu.h"
#include "Sky.h"
#include "help.h"
#include "Audioh.h"
extern int SOUND_ENABLED;
extern void killProgram(int mode);

//Clase q almacena todo lo relacionado con objetos no mobiles (es escenario,
//los portales, etc.)
class map{

	//Array de texturas q tiene el escenario
	texture *textureArray;
	
	//Numero de texturas
	int numTextures;
	
	//Array de habitaciones
	habitacion **habitacionObj;
	
	//Numero de habitaciones
	int numHabitaciones;

	//El cielo
	Sky fondo;

	//Sonido
	Audioh *sound;

	int ambientSound;
	int *soundRef;
	int *walkSound, *runSound;


public:

	//Constructor por defecto q inicializa variables
	map();

	//Destructor de la clase
	~map();
	
	//Devuelve el numero de habitaciones
	int getNumHabitaciones();
	
	//Te devuelve la habitacion q le pidas
	habitacion *getHabitacion(int pos);
	
	//Devuelve la textura q le pidas
	texture getTexture(int pos);
	
	//Devuelve el numero de texturas q hay
	int getNumTextures();
	
	//Aade una textura al mapa
	//Le pasas la textura y q numero es
	int addTexture(char *textura,int num);
	
	//Inicializa el array de habitaciones
	//Espera saber cuantas habitaciones hay
	//Devuelve 1 si todo ha ido bien y 0 en caso contrario
	int createHabitaciones(int num);
	
	//Inicializa el array de texturas
	//Espera saber cuantas texturas hay
	//Devuelve 1 si todo ha ido bien y 0 en caso contrario
	int createTextures(int num);
	
	//Inicializa una habitacion
	//Le has de pasar el id q tiene
	//Devuelve 1 si todo ha ido bien y 0 en caso contrario
	int addHabitacion(int id);

	Sky getSky();

	int loadSky(char *ruta);

	int loadSound(char *ruta);

	int playSound(int hab, int mode, GL3f pos);

	void stopSound();


};



#endif
