#include "messageControl.h"


messageControl::messageControl(float y_orig_old){

	//Cargamos la fuente
	fuente=new texto2D("TYPEFACE2.tga");
	y_orig=y_orig_old;
	numMessages=0;
	talkMessageActive=false;

};

messageControl::~messageControl(){
	delete[] talkMessage;
	//delete fuente;
	printf("MESSAGE_CONTROL DESTROYED\n");
}

void messageControl::addMessage(char *messageStr){
	//Si hemos excedido el maximo de mensajes, eliminamos el primero
	if (numMessages==MAX_MESSAGES){
		messageArray[0].time_left=0;
		killMessages();
	}
	//Aadimos el mensaje en el array de mensajes
	messageArray[numMessages]=message(messageStr);
	
	//Incrementamos el numero de mensajes que tenemos
	numMessages++;
};

void messageControl::drawMessages(){

	int j;

	//Destruimos los mensajes que han caducado
	killMessages();
	
	//Pintamos los mensajes
	for (j=0;j<numMessages;j++){
		glEnter2D(WIDTH,HEIGHT);
		//fuente->print(MESSAGE_X_ORIG,(y_orig+(j*SPACE_BETWEEN_MESSAGES)),messageArray[j].messageObj,1.0f);
			
		fuente->print(messageArray[j].messageObj,MESSAGE_X_ORIG,(y_orig+(j*SPACE_BETWEEN_MESSAGES)),1.0f,1.0f,0.0f,11.0f);
		glExit2D();
	}

	//Comprobamos si estamos en el modo "say" para escribir mensajes y, en caso afirmativo,
	//pintamos lo que hayamos escrito por pantalla
	if (talkMessageActive){
		glEnter2D(WIDTH,HEIGHT);
		fuente->print("Say: ",MESSAGE_X_ORIG+120,480-TALK_MESSAGE_Y,1.0f,1.0f,1.0f,10.0f);
		fuente->print(talkMessage,MESSAGE_X_ORIG+180,480-TALK_MESSAGE_Y,1.0f,1.0f,1.0f,10.0f);
		glExit2D();

	}


};

void messageControl::killMessages(){

	//Comprobamos si ha caducado algun mensaje. 
	for(int i=0;i<numMessages;i++){
		//Miramos si el mensaje que ocupa actualmente la posicion 0 ha caducado,
		//si es asi, lo eliminamos bajando todos los mensajes una posicion y volvemos
		//a comprobarlo. 
		//Si no ha caducado salimos del bucle
		if(messageArray[0].time_left<SDL_GetTicks()){
			messageArray[0].messageObj="";
			for (int j=0;j<numMessages-1;j++){
				messageArray[j]=message(messageArray[j+1]);
			}
			numMessages--;
		}
		else break;
	}

	

}


bool messageControl::isTalkMessageActive(){
	return talkMessageActive;
}

void messageControl::destroyTalkMessage(){
	talkMessageActive=false;
}

void messageControl::createTalkMessage(char *talkMessage_old){
	talkMessageActive=true;
	talkMessage=talkMessage_old;
}


void messageControl::translate(int num, char* letras){
	fuente->translate(num,letras);
}
