#ifndef _MESSAGECONTROL_H_
#define _MESSAGECONTROL_H_

#if WIN32
#include <windows.h>
#endif

#include <time.h>
#include <GL/gl.h>
#include <string.h>
#include <stdio.h>
#include "define.h"
#include "help.h"
#include <SDL/SDL.h>
#include "fuentes.h"

//Struct to load a message
struct message{
	char *messageObj;
	unsigned int time_left;

	message(){
		messageObj=0;
		time_left=0;
	}
	~message(){
	//	delete[] messageObj;
	}

	message(char *messageObj_old){
		messageObj=new char[MAX_MESSAGE_LENGTH];
		strcpy(messageObj,messageObj_old);
		time_left=SDL_GetTicks()+MESSAGE_TIME_LEFT;
	}
	message(const message &messageOld){
		messageObj=new char[MAX_MESSAGE_LENGTH];
		strcpy(messageObj,messageOld.messageObj);
		time_left=messageOld.time_left;
	}

	message& operator=(const message messageOld) {
		messageObj=new char[MAX_MESSAGE_LENGTH];
		strcpy(messageObj,messageOld.messageObj);
		time_left=messageOld.time_left;
		return *this;
	}

};


//Controls the text messages in screen
class messageControl{

	int numMessages;							//Number of messages
	float y_orig;								//The y original component
	message messageArray[MAX_MESSAGES];			//Array of messages in memory
	bool talkMessageActive;						//Indicates if we are writing something on the screen
	char *talkMessage;							//Pointer to the message writed in the class controles
	texto2D *fuente;							//Pointer to the class that draws the letters ont the screen
	
private:
	void killMessages();						//Kills all the messages that are out of date

public:
	messageControl(float y_orig_old);			//Inits vars and define the y orig
	~messageControl();							//Frees memory
	void addMessage(char *message);				//Add a message
	void drawMessages();						//Draw all the messages
	bool isTalkMessageActive();					//Returns true if you are in writing mode
	void destroyTalkMessage();					//Returns to the normal state (not writing)
	void createTalkMessage(char *talkMessage_old);  //Enters in the talk state
	void translate(int num, char* letras);			//The first paramater is the number of
													//the letter and the second parameter
													//returns the letters that are asigned
													//to that number
	
};








#endif

