#ifndef _RENDER_H_
#define _RENDER_H_

#if WIN32
#include <windows.h>
#endif


#include <SDL/SDL.h>
#include "opengl.h"
#include "structures.h"
#include "caracter.h"
#include "stage.h"
#include "mates.h"
#include "Interface.h"


//Clase q pinta todo por pantalla
class render {

	int modo; //Definimos las veces q ha de pintar
	GL3f night;
	unsigned int delay,nextChange;

private:
	//Carga la textura q le pidamos
	void setTexture(texture textureObj);
	
	//Pinta la camara, o lo q es lo mismo, la coloca donde vamos a mirar
	//Espera un objeto stage
	void pintaCamara(stage *fase);
	
	//Pinta el escenario.
	//Espera un objeto stage y un array de ints con el pvs de lo q ve	
	void pintaEscenario(stage *fase, int *PVS);
	
	//Pinta items.
	//Espera un objeto stage y un array de ints con el pvs de lo q ve
	void pintaItems(stage *fase, int *PVS);
	
	//Pinta enemigos
	//Espera un objeto stage y un array de ints con el pvs de lo q ve
	void pintaEnemigos(stage *fase, int *PVS);

#if _PVS
	//Pinta los portales
	//Espera un objeto stage y un array de ints con el pvs de lo q ve
	void pintaPortales(stage *fase, int *PVS);
#endif

	//Pinta los boundings de los personajes
	//Espera un objeto stage y un array de ints con el pvs de lo q ve
	void pintaBoundings(stage *fase, int *PVS);
	
	//Inicializa el vertex array
	//Espera el array de vertices normales y vertices de textura
	void beginVertexArray(float *vertexArray, float *textureArray);
	
	//Desactiva el vertex array
	void endVertexArray();
	
	//Pinta el vertex array
	void drawVertexArray(texture textura, int begin, int end, float A=-1.0f, float R=1.0f, float G=1.0f, float B=1.0f);

	//Pinta un objeto sin vertex array
	//Espera una textura, un array de vertices, un array de caras y cuantas caras ha de pintar
	void drawObject(texture textura, float *vertex, float *textureVertex, int numFaces, float A=-1.0f, float R=1.0f, float G=1.0f, float B=1.0f);

	//Pinta un bounding
	void drawBoundingCube(GLBounding bounding);

	//Pinta el cielo
	void drawSkyBox(Sky cielo,GL3f pos);

	
public:

	//Inicializa todos los parametros para el renderizado
	render();

	//Metodo al que le pasas un objeto stage y te pinta el mundo
	void dibuja(stage *fase);

};


	


#endif

