#include "stage.h"

stage::stage(char *ruta)
{
	maxPlayers=0;
	actualPlayers=0;
	
	camaraObj=new camara("goblin.car");
	enemigos=(enemy**)malloc(0);
	mensajes=new messageControl(30.0f);
	mapa=new map();
	numItemModels=0;
	numWeapons=0;

	//Cargamos el mapa
	if (!leeFichero(ruta)){
		printf("ERROR LOADING MAP %s\n",ruta);
		killProgram(0);
	}

};

stage::~stage()
{
	int i;

	delete mensajes;
#if _PVS
	delete[] PVS;
#endif
	for (i=0;i<numItems;i++)
		delete itemObj[i];

	delete[] itemObj;

	for (i=0;i<numItemModels;i++){
		delete itemModel[i];
	}
	delete[] itemModel;

	delete camaraObj;

	for (i=0;i<maxPlayers;i++){
		if (enemigos[i]) delete enemigos[i];
	}
	free (enemigos);

	for (i=0;i<numWeapons;i++) {
		delete weaponObj[i];
	}
	delete[] weaponObj;

	delete mapa;
	printf("STAGE DESTROYED\n");
}

int stage::leeFichero(char *ruta){

	//Variables temporales
	int contaItems=0;
	FILE *archivo;
	char *tempoString;
	int tempoInt=0,tempoInt2=0,numHab,numPortal=0,i=0,cont=0;
	int numFaces,numVertex,numTextures;
	GL3f tempoGL3f;
	GL4i tempoGL4i;
	GL2f tempoGL2f;
	GL3i tempoGL3i;

	float *arrayVertexTempo1;
	float *arrayVertexTempo2;
	float *arrayTextureVertexTempo1;
	float *arrayTextureVertexTempo2;
	int *arrayFacesTempo1;
	int *arrayFacesTempo2;
	int *arrayTextureFacesTempo1;
	int *arrayTextureFacesTempo2;
	int *arrayVertexPointer1;
	int *arrayVertexPointer2;
	tempoString=new char[100];
	

	chdir(getDirs(ruta));
	//Abrimos el archivo
	archivo=fopen (ruta,"r");
    chdir("../..");

	if (!archivo) return 0;

	
	//Empezamo a leer el archivo
	printf(" **** LOADING MAP: %s ****\n",ruta);

	//Creamos el array de habitaciones
	fscanf(archivo,"%s",tempoString);
	fscanf(archivo,"%d",&tempoInt);
	mapa->createHabitaciones(tempoInt);

	//Creamos el array de items
	fscanf(archivo,"%s",tempoString);
	fscanf(archivo,"%d",&numItems);
	itemObj=new control*[numItems];
	printf("Numero de items: %d\n",numItems);

	//Creamos el array de armas
	fscanf(archivo,"%s",tempoString);
	fscanf(archivo,"%d",&numWeapons);

	//Le sumo uno teniendo en cuenta la arma por defecto
	numWeapons++;
	if (numWeapons<=0 || numWeapons >10){
		printf("Invalid number of weapons\n");
		killProgram(0);
	}
	weaponObj=new weapon*[numWeapons];
	printf("Numero de armas: %d\n",numWeapons);

	//Arma por defecto
	weaponObj[0]=new weapon("pistola.wph");
	camaraObj->setWeapon(*weaponObj[0],weaponObj[0]->getMaxAmmo());


	fscanf(archivo,"%s",tempoString);
	fscanf(archivo,"%d",&numItemModels);
	itemModel=new object3d*[numItemModels];
	printf("Numero de modelos de item: %d\n\n",numItemModels);
	for (i=0;i<numItemModels;i++){
		fscanf(archivo,"%s",tempoString);
		fscanf(archivo,"%d",&tempoInt);
		fscanf(archivo,"%s",tempoString);
		sprintf(tempoString,"%s.mdh",tempoString);
		itemModel[tempoInt]=new object3d(tempoString);
		printf("ITEM %d: %s ADDED\n",tempoInt,tempoString);
	
	}

	printf("\n");
	for (i=1;i<numWeapons;i++){
		fscanf(archivo,"%s",tempoString);
		fscanf(archivo,"%d",&tempoInt);
		fscanf(archivo,"%s",tempoString);
		weaponObj[i]=new weapon(tempoString);
		printf("WEAPON %d: %s ADDED\n",tempoInt,tempoString);
	}

	
	printf("\n");


	//Creamos el array de texturas
	fscanf(archivo,"%s",tempoString);
	fscanf(archivo,"%d",&numTextures);
	mapa->createTextures(numTextures);
	printf("Numero de texturas: %d\n\n",numTextures);

	//Leemos todas las texturas y las aadimos a un array dentro del objeto mapa
	for (i=0;i<mapa->getNumTextures();i++){
		fscanf(archivo,"%s",tempoString);
		fscanf(archivo,"%d",&tempoInt);
		fscanf(archivo,"%s",tempoString);
		mapa->addTexture(tempoString,tempoInt);	
		printf("TEXTURE %d: %s ADDED\n",tempoInt,tempoString);
	}

	fscanf(archivo,"%s",tempoString);
	fscanf(archivo,"%d",&tempoInt);
	for (i=0;i<tempoInt;i++)
		for (tempoInt2=0;tempoInt2<6;tempoInt2++) fscanf(archivo,"%s",tempoString);

		
	//Leemos y creamos el PVS
	fscanf(archivo,"%s",tempoString);
	fscanf(archivo,"%s",tempoString);
#if _PVS
	PVS=new int[mapa->getNumHabitaciones()*mapa->getNumHabitaciones()];
	if(!cargaPVS(tempoString)) return 0;
	printf("PVS LOADED\n");
#endif
	fscanf(archivo,"%s",tempoString);
	fscanf(archivo,"%s",tempoString);
	if(!mapa->loadSound(tempoString)) return 0;
	printf("SOUND LOADED\n");

	fscanf(archivo,"%s",tempoString);
	fscanf(archivo,"%f",&RATIO);
	printf("RATIO LOADED: %f\n",RATIO);

	//Empezamos a cargar las habitaciones
	fscanf(archivo,"%s",tempoString);
	for (i=0;i<mapa->getNumHabitaciones();i++){
		numPortal=0;
			
		//Cargamos la habitacion en la clase mapa
		fscanf(archivo,"%d",&numHab);
		mapa->addHabitacion(numHab);
		printf("\nLOADING ROOM %d\n",numHab);
		fscanf(archivo,"%s %d",tempoString,&tempoInt);
#if _PVS		
		if (!mapa->getHabitacion(numHab)->createPortals(tempoInt)){
			printf("ERROR CREATING PORTALS\n");
			return 0;
		}
#endif
			
		//Buscamos todos los elementos que contiene
		do{
			fscanf(archivo,"%s",tempoString);
			if (!strcmp(tempoString,"HABITACION")) break;
			fscanf(archivo,"%s",tempoString);

			int numItemUsed=-1;
			//Miramos si encuentra un item
			if (!strcmp(tempoString,"ITEM")){
				fscanf(archivo,"%d",&tempoInt2);
											
				printf("  SETTING UP ITEM %d IN ROOM %d\n",tempoInt2,numHab);
				itemObj[contaItems]=new control(itemModel[tempoInt2]);
				//Carga el item en el array de items, le asigna el id correspondiente a la
				//habitacion donde se encuentra, coge su posicion y aumenta el contador de items
#if _PVS				
				itemObj[contaItems]->setId(numHab);
#endif
				fscanf(archivo,"%f %f %f",&tempoGL3f.x,&tempoGL3f.y,&tempoGL3f.z);
				tempoGL3f=tempoGL3f*RATIO;
				tempoGL3f.y+=0.05f;
				itemObj[contaItems]->setPos(tempoGL3f);
				itemObj[contaItems]->setRotationAngle(ROTATE_ANGLE_ITEMS);
				itemObj[contaItems]->activateRotation(ROTATE_SPEED_ITEMS);

				contaItems++;
			}
			else if (!strcmp(tempoString,"WEAPON")){
				fscanf(archivo,"%d",&tempoInt2);
				
				printf("  SETTING UP WEAPON %d IN ROOM %d\n",tempoInt2,numHab);
				itemObj[contaItems]=new control(weaponObj[tempoInt2]->getThirdView()->getObject3d());
				//Carga el item en el array de items, le asigna el id correspondiente a la
				//habitacion donde se encuentra, coge su posicion y aumenta el contador de items
#if _PVS				
				itemObj[contaItems]->setId(numHab);
#endif
				fscanf(archivo,"%f %f %f",&tempoGL3f.x,&tempoGL3f.y,&tempoGL3f.z);
				tempoGL3f=tempoGL3f*RATIO;
				itemObj[contaItems]->setPos(tempoGL3f);
				itemObj[contaItems]->setRotationAngle(ROTATE_ANGLE_ITEMS);
				itemObj[contaItems]->activateRotation(ROTATE_SPEED_ITEMS);

				contaItems++;
			}
			//Miramos si encuentra un portal
			else if(!strcmp(tempoString,"PORTAL")){
				GL3f *vertex;
				vertex=new GL3f[4];
#if _PVS
				//Creamos variables temporales
				GLBounding bounding= GLBounding();
		
				printf("  SETTING UP PORTAL\n");
#endif
				//Le asignamos una habitacion destino al portal
				fscanf(archivo,"%d",&tempoInt2);
#if _PVS
				mapa->getHabitacion(numHab)->setPortalNeighbour(numPortal,tempoInt2);
#endif
				//Leemos sus vertices y creamos un array con ellos
				for (tempoInt2=0;tempoInt2<4;tempoInt2++){

					fscanf(archivo,"%f %f %f",&vertex[tempoInt2].x,&vertex[tempoInt2].y,&vertex[tempoInt2].z);
#if _PVS
					vertex[tempoInt2]=vertex[tempoInt2]*RATIO;
#endif
				}
#if _PVS
				mapa->getHabitacion(numHab)->setPortalVertex(numPortal,vertex);
				delete vertex;
				numPortal++;
#endif
			}
			//Cargamos la habitacion en si
			else if(!strcmp(tempoString,"HAB")){
				printf("  SETTING UP ROOM\n");
				fscanf(archivo,"%s",tempoString);
				fscanf(archivo,"%d",&numVertex);

				//Guardamos todos los vertices en un array
				arrayVertexTempo1=new float[numVertex*3*2];
				for (cont=0;cont<numVertex*3;cont+=3){
					fscanf(archivo,"%f %f %f",&arrayVertexTempo1[cont],&arrayVertexTempo1[cont+1],&arrayVertexTempo1[cont+2]);
					arrayVertexTempo1[cont]*=RATIO;
					arrayVertexTempo1[cont+1]*=RATIO;
					arrayVertexTempo1[cont+2]*=RATIO;
				}

				fscanf(archivo,"%s",tempoString);
				fscanf(archivo,"%d",&numFaces);

				//*6... no tiene logica pero va bien :)
				arrayFacesTempo1=new int[numFaces*6];
				arrayFacesTempo2=new int[numFaces*3];
				arrayVertexPointer1=new int[numFaces*2];

				//Esta variable almacenara el vertexArray.
				//Se multiplica por 9 el numero de caras ya que cada cara tiene 3 vertices y
				//cada uno 3 componentes (x,y,z)
				arrayVertexTempo2=new float[numFaces*9];

				//Guardamos las caras en un array y la textura que les corresponde en otro
				for (cont=0;cont<numFaces;cont++){
					fscanf(archivo,"%d %d %d %d",&arrayFacesTempo1[(cont*3)],&arrayFacesTempo1[(cont*3)+1],&arrayFacesTempo1[(cont*3)+2],&arrayVertexPointer1[cont]);
				}

				fscanf(archivo,"%s",tempoString);
				fscanf(archivo,"%d",&numVertex);

				arrayTextureVertexTempo1=new float[numVertex*2];

				//Guardamos el array de vertices de textura	
				for (cont=0;cont<numVertex*2;cont+=2){
					fscanf(archivo,"%f %f",&arrayTextureVertexTempo1[cont],&arrayTextureVertexTempo1[cont+1]);
				}
				
				fscanf(archivo,"%s",tempoString);
				fscanf(archivo,"%d",&numFaces);
				arrayTextureFacesTempo1=new int[numFaces*3];
				arrayTextureFacesTempo2=new int[numFaces*3];

				//Esta variable almacenara el vertexArray.de texturas
				//Se multiplica por 6 el numero de caras ya que cada cara tiene 3 vertices y
				//cada uno 2 componentes (u,v)
				arrayTextureVertexTempo2=new float[numFaces*6];

				//Guardamos el array de caras de textura
				for (cont=0;cont<numFaces*3;cont+=3){
					fscanf(archivo,"%d %d %d",&arrayTextureFacesTempo1[cont],&arrayTextureFacesTempo1[cont+1], &arrayTextureFacesTempo1[cont+2]);
				}


				//Esta variable se desactivara cuando encontremos una textura nueva
				bool newTexture=true;
				int numHabTextures=0;

				//Buscamos el numero de texturas
				for (cont=0;cont<numTextures;cont++){
					newTexture=true;
					for (int cont2=0;cont2<numFaces && newTexture;cont2++){

						//Miramos en todas las caras hasta encontrar una que tenga la textura
						//que estamos buscando
						if (arrayVertexPointer1[cont2]==cont){

							//Si le encuentra, aumentamos el contador de texturas y desactivamos
							//el flag para buscar una nueva textura
							numHabTextures++;
							newTexture=false;
						}
					}
				
				}
							
				//Inicializamos el vertexPointer que almacenara la posicion del array de
				//vertices donde empieza una textura y a que textura se refiere
				arrayVertexPointer2=new int[(numHabTextures*2)+1];

				//Variables temporales
				int cont3=0,cont4=0;

				//Llenamos el vertex pointer y ordenamos las caras
				for (cont=0;cont<numTextures;cont++){
					newTexture=true;
					for (int cont2=0;cont2<numFaces;cont2++){
						if (arrayVertexPointer1[cont2]==cont){
							if (newTexture){
								arrayVertexPointer2[cont3]=cont4;
								arrayVertexPointer2[cont3+1]=cont;
								newTexture=false;
								// printf("Inicio %d Textura %d\n",arrayVertexPointer2[cont3],arrayVertexPointer2[cont3+1]);

								cont3+=2;
					
							}
							arrayFacesTempo2[cont4]=arrayFacesTempo1[(cont2*3)];
							arrayFacesTempo2[cont4+1]=arrayFacesTempo1[(cont2*3)+1];
							arrayFacesTempo2[cont4+2]=arrayFacesTempo1[(cont2*3)+2];
							arrayTextureFacesTempo2[cont4]=arrayTextureFacesTempo1[(cont2*3)];
							arrayTextureFacesTempo2[cont4+1]=arrayTextureFacesTempo1[(cont2*3)+1];
							arrayTextureFacesTempo2[cont4+2]=arrayTextureFacesTempo1[(cont2*3)+2];
							
							cont4+=3;
						}
						else if (arrayVertexPointer1[cont2]>=numTextures) printf ("ERROR (Texture out of range) Pointer= %d NumTextures= %d\n",arrayVertexPointer1[cont2],numTextures);
					}
				}

				//En la ultima posicion del vertex poineter guardo la longitud del array para
				//saber cuando acaba este
				arrayVertexPointer2[cont3]=numFaces*3;
	
				//Ordenamos los vertices
				for (cont=0;cont<numFaces*3;cont++){
					arrayVertexTempo2[(cont*3)]=arrayVertexTempo1[arrayFacesTempo2[cont]*3];
					arrayVertexTempo2[(cont*3)+1]=arrayVertexTempo1[(arrayFacesTempo2[cont]*3)+1];
					arrayVertexTempo2[(cont*3)+2]=arrayVertexTempo1[(arrayFacesTempo2[cont]*3)+2];

					arrayTextureVertexTempo2[(cont*2)]=arrayTextureVertexTempo1[(arrayTextureFacesTempo2[cont]*2)];
					arrayTextureVertexTempo2[(cont*2)+1]=arrayTextureVertexTempo1[(arrayTextureFacesTempo2[cont]*2)+1];
				}

				//Le pasamos toda la informacion a la habitacion correspondiente
				mapa->getHabitacion(numHab)->addVertex(arrayVertexTempo2,numFaces);
				mapa->getHabitacion(numHab)->addTextureVertex(arrayTextureVertexTempo2,numFaces);
				mapa->getHabitacion(numHab)->addTexturePointer(arrayVertexPointer2,numHabTextures);
							
/*
				delete[] arrayVertexTempo1;
				delete[] arrayVertexTempo2;
				delete[] arrayTextureVertexTempo1;
				delete[] arrayTextureVertexTempo2;
				delete[] arrayFacesTempo1;
				delete[] arrayFacesTempo2;
				delete[] arrayTextureFacesTempo1;
			    delete[] arrayTextureFacesTempo2;
				delete[] arrayVertexPointer1;
				delete[] arrayVertexPointer2;
				
*/			}
		
			
		}while(!feof(archivo));

	}


	
	//Cerramos el archivo
	fclose(archivo);

	//Liberamos memoria
	delete[] tempoString;

#if _PVS

#endif
	
	if (!mapa->loadSky("sky1.skh")) {
		printf("Couldn't load sky1.skh or one of his components\n");	
		return 0;
	}

	return 1;
}

void stage::update(){

	int j;

	//Actualizamos los items
	for (j=0;j<numItems;j++){
		itemObj[j]->update();
	}

	//Actualizamos los enemigos
	for (j=0;j<maxPlayers;j++){
		if (enemigos[j]) enemigos[j]->update();
	}

	//Actualizamos la camara

	camaraObj->update();
}

#if _PVS
int stage::cargaPVS(char *ruta){


	FILE* archivo;

	
	//Abrimos el archivo
	chdir(getDirs(ruta));
	archivo=fopen (ruta,"r");
	chdir("../..");

	if(!archivo) return 0;

	int tempoInt,x,y;

	//Cojemos el numero de habitaciones del mapa
	int numHabitaciones=mapa->getNumHabitaciones();

	//Nos saltamos la primera linia ya que no tiene informacion interesante
	for (x=0;x<=numHabitaciones;x++){
		fscanf(archivo,"%d",&tempoInt);
	}
	
	//Vamos leyendo el archivo y llenando el PVS
	for(y=0;y<numHabitaciones;y++){

		//El primer numero no sirve de nada y lo pasamos
		fscanf(archivo,"%d",&tempoInt);
		for (x=0;x<numHabitaciones;x++){
			fscanf(archivo,"%d",&tempoInt);
			if (tempoInt>1 || tempoInt<0) return 0;
			PVS[(y*numHabitaciones)+x]=tempoInt;
			printf("%d ",tempoInt);
		}
		printf("\n");
	}

	return 1;
}
#endif

control *stage::getItem(int pos){ 
	if (pos>=0 && pos<=numItems) return itemObj[pos];
	else return 0;
}

#if _PVS
int *stage::getPVS(int pos){
	int *PVS_tempo,j=0;
	int numHabitaciones=mapa->getNumHabitaciones();

	//Creamos un array en el cual guardamos el PVS de la habitacion que le pidamos
	PVS_tempo=new int[numHabitaciones];
	for (int i=pos*numHabitaciones;i<numHabitaciones+(pos*numHabitaciones);i++,j++){
		PVS_tempo[j]=PVS[i];
	}
	return PVS_tempo;
}
#endif
	
void stage::setCamaraPos(GL3f posCam,bool collision){

	//Antes de pasarle la nueva posicion a la camara, comprobamos que no cambiamos de habitacion
	if (collision){
#if _PVS
		int id=checkCamera(posCam);
		if (id!=camaraObj->getId())	printf ("Actual Hab: %d\n",id);
		if (id>=0 && id<mapa->getNumHabitaciones()) camaraObj->setId(id);
#endif
	}
	camaraObj->setPos(posCam);
}
void stage::setCamaraObj(double yawH, double yawV){
	camaraObj->setObj(yawH, yawV);
}

GLBounding stage::getCamaraBounding(){
	return camaraObj->getBounding();
}

#if _PVS
int stage::checkCamera(GL3f pos){

	habitacion *habTempo=mapa->getHabitacion(camaraObj->getId());

	GL3f intersectionPoint;
	GL3f linia[]={camaraObj->getPos(), pos};

	GL3f poli1[3];
	double orig[3];
	double dir[3];

	GL3f tempo;
	tempo=linia[1] - linia [0];

	for (int i=0;i<habTempo->getNumPortals();i++){
		GL3f *vertex_=habTempo->getPortalVertex(i);
		
		
		// CUTRADA
		poli1[0] = vertex_[0];
		poli1[1] = vertex_[1];
		poli1[2] = vertex_[3];

		orig[0] = linia[0].x;
		orig[1] = linia[0].y;
		orig[2] = linia[0].z;

		dir[0] = (linia[1].x - linia[0].x);
		dir[1] = (linia[1].y - linia[0].y);
		dir[2] = (linia[1].z - linia[0].z);

		
		double t = testline(linia, intersectionPoint, poli1);
		if ( (t>0.0) && (t <= 1.0) ) {
		/*	printf("portal:\n");
			poli1[0].print();
			poli1[1].print();
			poli1[2].print();
			printf("linia: \n");
			linia[0].print();
			linia[1].print();
			printf("\n");
*/
	//		printf("COLISION CON EL PLANO\n");
			if ( InsidePolygon(intersectionPoint, poli1,3)) {
				return habTempo->getPortalNeighbour(i);
			} else {
				poli1[0] = vertex_[0];
				poli1[1] = vertex_[2];
				poli1[2] = vertex_[3];

				if ( InsidePolygon(intersectionPoint, poli1,3)) {
					return habTempo->getPortalNeighbour(i);
				}
			}
		}
	
		
		
	}
	
	return camaraObj->getId();
}
#endif

int stage::getNumItems(){
	return numItems;
};

#if _PVS
int stage::getCamaraId(){ 
	return camaraObj->getId();
}
#endif

GL3f stage::getCamaraPos(){
	return camaraObj->getPos();
}

GL3f stage::getCamaraObj(){
	return camaraObj->getObjPos();
}

messageControl *stage::getMessageControl(){
	return mensajes;
}

map *stage::getMap(){
	return mapa;
}

bool stage::addEnemy(char *ruta, char *nick, int pos){
	if (pos>=maxPlayers) {
		enemigos=(enemy**)realloc(enemigos,sizeof(enemy**)*(pos+1));
		if (!enemigos) exit(0);
		for (int i=maxPlayers;i<pos+1;i++) {
			enemigos[i]=0;
		}
		maxPlayers=pos+1;
	}
	
	enemigos[pos]=new enemy(ruta);
	enemigos[pos]->setNick(nick);
	enemigos[pos]->setWeapon(*weaponObj[0],weaponObj[0]->getMaxAmmo());
	actualPlayers++;
		
	
	return true;
}

int stage::getMaxPlayers(){
	return maxPlayers;
}
enemy *stage::getEnemy(int which){
	if (which>=0 && which<maxPlayers){
		return enemigos[which];
	}
	return 0;
}

bool stage::killEnemy(int who){
	if (enemigos[who]) delete enemigos[who];
	else return false;
	enemigos[who]=0;
	actualPlayers--;
	if (who+1==maxPlayers) {
		maxPlayers--;
		enemigos=(enemy**)realloc(enemigos,sizeof(enemy**)*who+1);
	}
	return true;
}

int stage::getActualPlayers(){
	return actualPlayers;
}

control *stage::getCamFirstView(){
	return camaraObj->getWeapon()->getFirstView();
}

control *stage::getCamThirdView(){
	return camaraObj->getWeapon()->getThirdView();
}


void stage::setCamaraDNI(int num){
	camaraObj->setDNI(num);
}

int stage::getCamaraDNI(){
	return camaraObj->getDNI();
}

void stage::setCamaraNick(char *nick){
	camaraObj->setNick(nick);
}

char *stage::getCamaraNick(){
	return camaraObj->getNick();
}

void stage::setCamaraId(int id){
	camaraObj->setId(id);
}

bool stage::existsEnemy(int who){
	if (who<0 || who>=maxPlayers) return false;
	if (enemigos[who]) return true;
	else return false;
}

weapon *stage::getCamaraWeapon(){
	return camaraObj->getWeapon();
}

Interface *stage::getCamaraInterface(){
	return camaraObj->getInterface();
}


